	DEVICE ZXSPECTRUM128
	ORG 30000
BackBuffer .EQU 65000
		
Start		
	EI
	LD SP,65535
	
StartGame
	LD A,6
	LD (Lives),A
	LD A,1
	LD (LevelNr),A	
	XOR A
	LD (ExitMenu),A
	LD (LoseLife),A	
	LD HL,0
	LD (Score),HL
		
				
	CALL GameMenu
	
	;returns here after game menu		
StartGame1
	;start of new level

	;dark screen
	XOR A
	OUT (254),A
	LD HL,22528
	LD (HL),A
	LD DE,22529	
	LD BC,767		
	LDIR
;level text	
	LD A,(LevelNr)
	ADD A,28
	LD (LevelNrText),A
		
	LD HL,18508
	LD DE,LevelStart
	CALL Typetext
;find name
	LD HL,GirlNames-2
	LD A,(LevelNr)
FindName
	INC HL
	INC HL
	DEC A
	JR NZ,FindName
	LD E,(HL)
	INC HL
	LD D,(HL);name address IN DE
	LD HL,18572
	CALL Typetext
	
	LD B,150
StartLevelDelay
	HALT
	DJNZ StartLevelDelay						
			
;----------		
					
;clear screen AND set attributes
	XOR A
	OUT (254),A
	LD HL,16384
	LD (HL),A
	LD DE,16385	
	LD BC,6143		
	LDIR	
	
	;sign
	LD HL,20493
	LD BC,6*256+4
	LD DE,Sign1
	LD IX,7 ;this cell contains 17(empty byte)
	CALL DrawTile			
	
	;Attributes	
	LD A,64+(8*0)+7
	LD HL,22528
	LD (HL),A
	LD DE,22529	
	LD BC,767		
	LDIR
	
	;Bricks
	CALL DisplayBricks		

	
StartGame2
	;game jumps here when player loses A life
		
		
	LD A,128
	LD (BatX),A
	LD (WaitForFireFlag),A ; change flag-make the game waiting for pressing fire
				 ;to Set the ball moving
	LD A,134
	LD (BallX),A
	LD A,168
	LD (BallY),A
	LD A,254
	LD (BallSpeedY),A
	LD A,32
	LD (BatMomentum),A	
		
	XOR A
	LD (DeathStatus),A
	LD (WinStatus),A
	
	;determine random ball Direction (left/right/straightforward)
	LD A,R
	AND 00000011b;0-3

	ADD A,255; we get 255,0,1,2
	CP 2
	JR NZ,BallDir
	DEC A;avoid too sharp angle at start	
BallDir		
	LD (BallSpeedX),A	
		

	CALL DisplayBar; types score level AND lives	
	
;count ball H AND L
	CALL CountBallHL
	LD A,H
	LD (BallOldH),A
	LD A,L
	LD (BallOldL),A		
;clear graphic back buffer for ball
	LD DE,BackBuffer
	LD B,16
	XOR A
ClearBackBuffer
	LD (DE),A
	INC DE
	DJNZ ClearBackBuffer
		
;----Wait for pressing fire
	
WaitForFire
	CALL CountBallHL
	HALT
						
	CALL DisplayBat
	CALL DisplayBall
	
	LD A,(BallL);update old ball position
	LD (BallOldL),A

	LD A,(ControlOption)
	OR A
	JR Z,WaitForFire2 ;determine keyboard OR joystick
	
	;joystick	
	LD BC,31 
	IN A,(C)
	BIT 4,A
	JR NZ,WaitForFire3; fire pressed
	JR WaitForFire4
			
	;keyboard	
WaitForFire2		
	LD BC,32766 
	IN A,(C)
	BIT 2,A
	JR Z,WaitForFire3; fire pressed
	JR WaitForFire4

WaitForFire3
	XOR A
	LD (WaitForFireFlag),A ;make ball moving			

WaitForFire4
	JR Control ;go to bat moving rOUTine
		     ;if fire was not pressed after moving bat program Returns here
							
	JR WaitForFire
	
WaitForFireFlag	.BYTE 0 		
		
;---------MAIN LOOP-------------					
;-------controling bat-----		
;bat movement
Control
	LD A,(ControlOption)
	OR A
	JR Z,ControlByKeys	
ControlByJoy					
	LD BC,31
	IN A,(C);read joystick
	CP 1
	JR Z,GoRight
	;go left
	CP 2
	JP Z,GoLeft					
	
	XOR A
	LD (BatMoveDirection),A ;not moving
	LD A,32
	LD (BatMomentum),A;not moving so lost momentum
	
			
	LD A,(WaitForFireFlag) ;determine where program jumps if noleft/right pressed
		 			;(setting Initial position OR proper game
	OR A
	JR NZ,WaitForFire	
	JP MainLoop
		
ControlByKeys				
	LD BC,57342
	IN A,(C);read joystick
	BIT 0,A; p
	JR Z,GoRight
	BIT 1,A; o
	JR Z,GoLeft
		
	XOR A
	LD (BatMoveDirection),A ;not moving
	LD A,32
	LD (BatMomentum),A;not moving so lost momentum
	
	LD A,(WaitForFireFlag) 
	OR A
	JP NZ,WaitForFire	
	JP MainLoop
		
;------------------------		
	
GoRight
	LD HL,BatX
	LD A,(HL)
	CP 220
	JR C,GoRight2	
	
	;right screen edge reached
	LD A,(WaitForFireFlag)
	OR A	
	JP Z,MainLoop
	JP WaitForFire	
		
	;no right screen edge reached
GoRight2
	LD DE,BatMomentum
	LD A,(BatMoveDirection)
	CP 2 ;check if bat was already moving right
	JR NZ,GoRight4;not moving so set moving variables
	
	;already moving left
	
	LD A,(DE);momentum
	OR A ;check if reached higher speed OR still reaching
	JR NZ,GoRight3; still gaining momentum
	
	;momentum reached		
	JR GoRight5
GoRight3
	LD A,(DE)
	DEC A ;decrease momentum flag, when it reaches 0, the bat will move faster
	LD (DE),A
	JR GoRight6	
					
GoRight4
	LD A,2;set going left
	LD (BatMoveDirection),A
	LD A,32
	LD (DE),A;set Initial momentum	
	JR GoRight6		
GoRight5
	;moving faster	
	INC (HL)
	INC (HL);change bat position
	LD A,(WaitForFireFlag)
	OR A
	JR Z,GoRight6			
	LD HL,BallX ;change ball position if waiting for fire
	INC (HL)
	INC (HL)
				
GoRight6
	LD HL,BatX
	INC (HL);change bat pos
	INC (HL)
		
	LD A,(WaitForFireFlag)
	OR A	
	JR Z,MainLoop ;no waiting for fire, so go to moving ball independently
	
	;move ball with bat when waiting for fire
	LD HL,BallX
	INC (HL)
	INC (HL)
	JP WaitForFire				
				
;--------
GoLeft
	LD HL,BatX
	LD A,(HL)
	CP 11
	JR NC,GoLeft2
	;left screen edge reached
	LD A,(WaitForFireFlag)
	OR A	
	JR Z,MainLoop
	JP WaitForFire	
		
	;no left screen edge reached	
GoLeft2
	LD DE,BatMomentum
	LD A,(BatMoveDirection)
	CP 1 ;check if bat was already moving left
	JR NZ,GoLeft4;not moving so set moving variables
	
	;already moving left
	
	LD A,(DE);momentum
	OR A ;check if reached higher speed OR still reaching
	JR NZ,GoLeft3; still gaining momentum
	
	;momentum reached		
	JR GoLeft5
GoLeft3
	LD A,(DE)
	DEC A ;decrease mometum flag, when it reaches 0, the bat will move faster
	LD (DE),A
	JR GoLeft6	
					
GoLeft4
	LD A,1;set going left
	LD (BatMoveDirection),A
	LD A,32
	LD (DE),A;set Initial momentum	
	JR GoLeft6		
GoLeft5
	;moving faster
	DEC (HL)
	DEC (HL);change bat position		
	LD A,(WaitForFireFlag)
	OR A
	JR Z,GoLeft6			
	LD HL,BallX ;change ball position if waiting for fire
	DEC (HL)
	DEC (HL)
GoLeft6
	LD HL,BatX	
	DEC (HL);change bat pos
	DEC (HL)
		
	LD A,(WaitForFireFlag)
	OR A	
	JR Z,MainLoop ;no waiting for fire, so go to moving ball independently
	
	;move ball with bat when waiting for fire
	LD HL,BallX
	DEC (HL)
	DEC (HL)
	JP WaitForFire				
				
	
		
;--------------------------------
MainLoop
	HALT
	
				
MainLoop2
	CALL DisplayBat ;displaying bat	
	
	CALL ChangeBallCoors
	CALL DisplayBall ;displaying ball						
	
	CALL DisplayBar
		
	CALL CheckContactWithBat
		
	CALL HitBrick				
								
;current pos becomes old pos
	LD A,(BallH)
	LD (BallOldH),A
	LD A,(BallL)
	LD (BallOldL),A
		
	;check if Death happened
	LD A,(DeathStatus)
	OR A
	JP NZ,Death	
	
	;Check if end of level
	LD A,(WinStatus)
	OR A
	JP NZ,WinLevel
		
	JP Control

	
;--------Game Data--------
BatX				.BYTE 128; ;bat position (0-255)
BatL  				.BYTE 16;Bat L of HL register (H is constant) 
BatShift			.BYTE 0;shift from exact square position (0-7)

BallX				.BYTE 134
BallY				.BYTE 168
BallH				.BYTE 0
BallL				.BYTE 0
BallShift			.BYTE 0
		
BallOldH			.BYTE 0
BallOldL			.BYTE 0
		
BallSpeedX			.BYTE 0
	
BallSpeedY			.BYTE 0								

BatMomentum 		.BYTE 0
BatMoveDirection	.BYTE 0 ;not moving=0,left=1,right=2

LevelNr				.BYTE 1
Lives				.BYTE 3
BricksNumber		.BYTE 0
		
		
DeathStatus	.BYTE 0		
WinStatus	.BYTE 0
LoseLife	.BYTE 0


;----------------------------------------
;include other files
	INCLUDE <Routines.asm>
	INCLUDE <LevelData.asm>
	INCLUDE <Graphics.asm>
	INCLUDE <Girl1.asm>
	INCLUDE <Girl2.asm>
	INCLUDE <Girl3.asm>
	INCLUDE <Girl4.asm>
	INCLUDE <Girl5.asm>
	INCLUDE <Girl6.asm>
	INCLUDE <Girl7.asm>
	INCLUDE <Girl8.asm>
	
;---------
	SAVESNA "C&B.sna",Start