
GameMenu
	;clear screen
	XOR A
	OUT (254),A ;set ORder color
	LD HL,16384	
	LD (HL),A
	LD DE,16385	
	LD BC,6911
	LDIR	
	
	;menu elements
	;logo
	LD HL,16499
	LD BC,6*256+4
	LD DE,Sign1
	LD IX,7 ;this cell contains 17(empty byte)
	CALL DrawTile		
	;girl
	LD HL,18434
	LD BC,12*256+8
	LD DE,MenuGirl ;draw girl (without moving leg)
	CALL DrawTile
	
	;bricks under girl
	LD C,5
	LD DE,MenuBrick
	LD HL,20482
DrawMenuBricks1
	LD B,5
DrawMenuBricks2
	PUSH HL
	PUSH DE
	PUSH BC
	LD BC,2*256+1
	CALL DrawTile
	POP BC
	POP DE
	POP HL
	INC L
	INC L
	DJNZ DrawMenuBricks2
	LD A,L
	ADD A,22 ;go to next line of bricks
	LD L,A
	DEC C
	JR NZ,DrawMenuBricks1
	
	LD C,5
	LD DE,MenuBricksColors
	LD HL,22528+514
DrawBricksColors1
	LD B,5
DrawBricksColors2
	LD A,(DE)
	LD (HL),A
	INC L
	LD (HL),A
	INC L
	INC DE
	DJNZ DrawBricksColors2
	LD A,L
	ADD A,22 ;go to next line of bricks
	LD L,A
	DEC C
	JR NZ,DrawBricksColors1
	

	
TypeMenuTexts
	LD HL,18445
	LD DE,KeysText
	CALL Typetext
	LD HL,18509
	LD DE,JoyText
	CALL Typetext
	LD HL,18573
	LD DE,StartText
	CALL Typetext
	LD HL,20528
	LD DE,AuthorText
	CALL Typetext

;-------		
AnimLeg
	LD DE,Leg1
	CALL DrawLeg
	LD DE,Leg2
	CALL DrawLeg
	LD DE,Leg3
	CALL DrawLeg
	LD DE,Leg2
	CALL DrawLeg
	LD A,(ExitMenu)
	OR A
	RET NZ; leave menu if 3 pressed
	JR AnimLeg		
;----		
DrawLeg
	LD B,12
DrawLegDelay
	HALT
	CALL TestMenuKeys
	DJNZ DrawLegDelay	
	LD HL,18668
	LD BC,518
	CALL DrawTile ;draw leg	frame 2(going back)
	RET
;------------			
TestMenuKeys
	PUSH BC
	PUSH DE	
	CALL ChangeMenuAttr
	LD BC,63486
	IN A,(C)
	POP DE
	POP BC
			
	BIT 0,A
	CALL Z,SelectKeyboard
	BIT 1,A
	CALL Z,SelectJoy
	BIT 2,A
	CALL Z,SetExitMenu;pressed 3=leave menu
	RET
		
SelectKeyboard
	PUSH AF
	XOR A
	LD (ControlOption),A
	POP AF	
	RET
SelectJoy
	PUSH AF					  
	LD A,1
	LD (ControlOption),A
	POP AF	
	RET
SetExitMenu
	LD HL,ExitMenu
	INC (HL)
	RET
					
ExitMenu .BYTE 0				
;-------			
ChangeMenuAttr
	;highlight chosen option (keyboard OR joystick)
	LD DE,22797 ;keyboard line
	LD HL,22861	;joystick line
	LD A,(ControlOption)
	OR A
	JR Z,MenuAttr1	
	EX DE,HL;invert colors of lines if necessary		

MenuAttr1
	LD A,71
	LD B,19
MenuAttr2			
	LD (DE),A ;fill chosen line with  attribute
	INC DE
	DJNZ MenuAttr2
		
	LD A,5
	LD B,19
MenuAttr3
	LD (HL),A
	INC HL
	DJNZ MenuAttr3;fill unchosen line with  attribute
	RET
ControlOption .BYTE 0 ;0-keyboard,1-joystick		

;---------------		
DrawGirl		
;Girl number in A
	;count where girl data begin
	LD HL,GirlsData-7
	LD DE,7
	LD B,A	
FindGirl		
	ADD HL,DE
	DJNZ FindGirl	
		
	;read data
	
	;border AND background
	PUSH HL
	XOR A
	LD HL,16384	
	LD (HL),A
	LD DE,16385	
	LD BC,6143
	LDIR	
	POP HL	
	PUSH HL	
	LD A,(HL)
			
	OUT (254),A ;set border color
	SLA A
	SLA A
	SLA A	
	LD HL,22528
	LD (HL),A
	LD DE,22529
	LD BC,767
	LDIR ;fill background with the same color as border
	POP HL	
	INC HL	
		
	PUSH HL
	POP IX ;empty byte
	INC HL; 	
			
	LD E,(HL)
	INC HL
	LD D,(HL);graphics
	INC HL
	LD B,32
	LD C,(HL);size			
	PUSH DE
	INC HL
	LD E,(HL)
	INC HL
	LD D,(HL)
	EX DE,HL
	POP DE;position		
	
;---------------------------
DrawTile
		
;IX-empty byte
;HL-position
;DE-data address
;BC-size												
; stores address of sprite IN screen-HL AND its size-BC for further use
;by attributes rOUTine
	PUSH HL
	PUSH BC			
						
		
;this loop draw "C" lines of chars
DrawGirl1		PUSH HL
			PUSH BC
		
;this loop4 draws one line of chars
DrawGirl2					
					PUSH HL
					LD A, (DE)
					
					
					CP (IX+0)	  ; compare with empty byte
					 	  ; when it is detected program jumps to another char
						  ; this rOUTine saves data space	
					
					JR Z, DrawGirl3 ; when first byte is 16 it is an empty char
							;so skip it AND go to next char 
							
					
;this loop draws one char
				LD A, (DE)
					LD (HL),A ;repeated 8 times, quicker than A loop
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					INC H
					INC DE
				LD A, (DE)
					LD (HL),A
					
						
DrawGirl3			INC DE
				POP HL ;restores H to address of upper row of the line
				INC L	;moves one char right 
					 
				DJNZ DrawGirl2 
		
			POP BC
			POP HL		
			; goes to another line of chars of girl picture
			LD A,L
			ADD A,32
			LD L,A
			JR NC,DrawGirl4;not carry=no going to next segment, so no H changes needed
				
				;change H only if going to next screen segment	
				LD A,H
				ADD A,8
				LD H,A
					
DrawGirl4			
			DEC C ;decrease number of chars line IN sprite yet to do
			JR NZ, DrawGirl1
		
; drawing tile is finished
; now restores size of the tile IN BC, its corner IN HL
;  DE is already increased to next byte where attributes data begin
						
		POP BC
		POP HL		
						
		
;ATTRIBUTES
;BC should contain sprite size (B-width C-height)
;DE should contain start of attributes data		
;HL should contain address of firt byte of attr		
	
;Transforms point address to attribute address
		
GirlAttr
		LD A,80
		SRL H
		SRL H
		SRL H
		ADD A,H		
		LD H,A
;loop1 draw C lines of attributes
GirlAttr1 	PUSH BC
		PUSH HL
		
;loop2 draw one line of attributes
GirlAttr2   LD A,(DE)
		LD (HL),A
		INC HL ;goes to next square IN the row
		INC DE
		DJNZ GirlAttr2
	
		POP HL
		PUSH DE ;    goes to
		LD DE,32 ;   next row
		ADD HL,DE ;  of 
		POP DE ;	 attributes	
		POP BC
		DEC C ;decreases number of lines yet to do 
		JR NZ, GirlAttr1
		
		RET
		
GirlsData		
	.BYTE 5;border
	.BYTE 17; empty byte
	.WORD Girl1 ;graphics			
	.BYTE 20 ;size(number of char lines)
	.WORD 16384+64 ;position
		
	
	.BYTE 0
	.BYTE 17
	.WORD Girl2 ; graphics			
	.BYTE 16 ;size(number of char lines)
	.WORD 16384+128 ;position
		
	.BYTE 1
	.BYTE 129
	.WORD Girl3 ; graphics			
	.BYTE 18 ;size(number of char lines)
	.WORD 16384+96 ;position
		
	.BYTE 4
	.BYTE 17
	.WORD Girl4 ; graphics			
	.BYTE 17 ;size(number of char lines)
	.WORD 16384+96 ;position
	
	.BYTE 2
	.BYTE 17
	.WORD Girl5 ; graphics			
	.BYTE 18 ;size(number of char lines)
	.WORD 16384+96 ;position

	.BYTE 1
	.BYTE 129
	.WORD Girl6 ; graphics			
	.BYTE 19 ;size(number of char lines)
	.WORD 16384+64 ;position

	.BYTE 6;border
	.BYTE 129; empty byte
	.WORD Girl7; graphics			
	.BYTE 14 ;size(number of char lines)
	.WORD 16384+160 ;position
		
	.BYTE 0;border
	.BYTE 17; empty byte
	.WORD Girl8; graphics			
	.BYTE 14 ;size(number of char lines)
	.WORD 16384+160 ;position
	
;----------------------
		
;takes "human" coordinates of sprite x(0-255) y(0-192)
;AND turn them to HL address		
		
XYtoHL
		
;B contains x, C contains y
		
	LD A,C
	AND 00000111b
	LD H,A
	LD A,C
	RRA
	RRA
	RRA
	AND 00011000b
	OR H
	OR 01000000b
	LD H,A
		
	LD A,B
	RRA
	RRA
	RRA
	AND 00011111b
	LD L,A
	LD A,C
	RLA
	RLA
	AND 11100000b
	OR L
	LD L,A
	RET
		
;-----BOTTOMBAR-------
DisplayBar
	LD DE,BottomBar
	LD HL,20705
		
	LD B,30
DisplayBar2	
	PUSH HL

 	LD A,(DE)
	CP 16;16 means empty char	
	JR Z,DisplayBar3	;skip empty char	
		
	LD (HL),A
	INC H	
	INC DE
	 	LD A,(DE)
	LD (HL),A
	INC H	
	INC DE
	 	LD A,(DE)
	LD (HL),A
	INC H	
	INC DE
	 	LD A,(DE)
	LD (HL),A
	INC H	
	INC DE
	 	LD A,(DE)
	LD (HL),A
	INC H	
	INC DE
	 	LD A,(DE)
	LD (HL),A
	INC H	
	INC DE
	 	LD A,(DE)
	LD (HL),A
	INC H	
	INC DE
		LD A,(DE)
	LD (HL),A
		
DisplayBar3	
	INC DE
	POP HL
	INC L
	DJNZ DisplayBar2
	
	;display attrs
	LD HL,23265
	LD B,30
DisplayBar4	
	LD A,(DE)
	LD (HL),A
	INC DE
	INC L
	DJNZ DisplayBar4		
;display bar numbers,lives,level AND score
		
;lives
	LD DE,LivesDisp
	LD A,(Lives)
	ADD A,28
	LD (DE),A
	LD HL,20711
	CALL Typetext	
;level nr
	LD DE,LevelDisp
	LD A,(LevelNr)
	ADD A,28
	LD (DE),A
	LD HL,20733
	CALL Typetext
;----------				
;Score
CountScore
;routine takes value written in Score or hiscore variable and enables to display it into screen
	LD HL,(Score)
;1000
	LD DE,1000
	XOR A
CountScore1		
	INC A
	SBC HL,DE	
	JR NC,CountScore1
	DEC A
	ADD HL,DE
	ADD A,28
	LD (Score1),A
;100
	LD DE,100
	XOR A
CountScore2		
	INC A
	SBC HL,DE	
	JR NC,CountScore2
	DEC A
	ADD HL,DE
	ADD A,28
	LD (Score2),A
;10
	LD DE,10
	XOR A
CountScore3		
	INC A
	SBC HL,DE	
	JR NC,CountScore3
	DEC A
	ADD HL,DE
	ADD A,28
	LD (Score3),A
;1
	XOR A
	LD DE,1
CountScore4
	INC A
	SBC HL,DE
	JR NC,CountScore4
	DEC A
	ADD A,28
	LD (Score4),A
	
TypeScore	
	LD HL,20720
	LD DE,Score1
	CALL Typetext					
	RET
					
LivesDisp
	.BYTE 28,0
LevelDisp
	.BYTE 28,0		
Score .WORD 0
Score1 .BYTE 28
Score2 .BYTE 28
Score3 .BYTE 28
Score4 .BYTE 28
	 .BYTE 28
	 .BYTE 0
					
;---------DISPLAYING BAT----------------		
;------counting bar position and frame--------	
DetermineBatPos
	
DisplayBat		
			
;determine bat position
	LD A,(BatX)
	LD C,A
	AND 00000111b;extract shift
	LD (BatShift),A;store shift
	LD B,A;shift IN B	
	LD A,C
	AND 11111000b;
	RRA
	RRA
	RRA ;divide by 8 to get 0-31=BatL
	OR 11000000b; the last bur one char line
	LD (BatL),A	;write BatLposition			
;determine frame
	LD HL,Bat0
	LD DE,16; adds 16 bytes for one pixel shift, 32 for 2 pixels shift )bat move is 32 pixels)
			
	LD A,B
	OR A
	JR Z,DrawBat1; if shift=0 no need to count frame
					
BatFrame	
	ADD HL,DE
	DJNZ BatFrame
			 	
;-------Drawing bat-----------	
DrawBat1		
	EX DE,HL;bat sprite address IN DE
	
	LD A,(BatL)
	LD L,A
	LD H,80;bat position IN HL
	
	LD C,L
	LD B,8		
DrawBat2	
	;one line
	LD L,C	
		
	LD A,(DE);read graphics 
	LD (HL),A;AND put to screen
	INC L; next collumn
	INC DE; next graphics byte
	
	LD A,(DE);read graphics 
	LD (HL),A;AND put to screen
	INC L; next collumn
	INC DE; next graphics byte
	
	LD A,(DE);read graphics 
	LD (HL),A;AND put to screen
	INC L; next collumn
	INC DE; next grsphics byte
			
	LD A,(DE);read graphics 
	LD (HL),A;AND put to screen
	INC L; next collumn
	INC DE; next graphics byte
				
	INC H;next line
	DJNZ DrawBat2
	RET					
;-------------DISPLAY BALL----------------------
DisplayBall
;----Restore graphics behind ball------
	
RestoreBack1
	LD A,(BallOldH)
	LD H,A
	LD A,(BallOldL)
	LD L,A
	
	LD A,H
	AND 00000111b
	LD B,A
	LD C,A;nr of lines IN bottom char line	
	LD A,8
	SUB B
	LD B,A;nr of lines IN top char line
	
	LD DE,BackBuffer
	PUSH HL
	;top line of background
RestoreBack2
	LD A,(DE)
	LD (HL),A;left char
	INC L
	INC DE	
	
	LD A,(DE)
	LD (HL),A
	DEC L
	INC DE;right char
	INC H
	DJNZ RestoreBack2
	
	;count bottom line	
	LD B,C; lines left to do
	POP HL
	LD A,C
	OR A
	JR Z,RestoreBackEnd
		
	LD A,H
	AND 11111000b
	LD H,A

	LD A,L
	ADD A,32
	LD L,A
	JR NC, RestoreBack3	
	LD A,H
	ADD A,8
	LD H,A
	;bottom line of background
					
RestoreBack3
	LD A,(DE)
	LD (HL),A;left char
	INC L
	INC DE	
	
	LD A,(DE)
	LD (HL),A
	DEC L
	INC DE;right char
	INC H
	DJNZ RestoreBack3
RestoreBackEnd
	;background finished	
;-------Drawing ball--------		
;--------	
ClearBrickWhenNeeded
	LD A,(ClearBrickNeeded)
	OR A
	JR Z,ClearBatSizes
	
	LD HL,(ClearBrickHL)		
	
	XOR A	
ClearBrick1	
	LD B,8
ClearBrick2						
	LD (HL),A
	INC L
	LD (HL),A
	INC L
	LD (HL),A
	DEC L
	DEC L
	INC H
	DJNZ ClearBrick2
	;increase score
	LD HL,(Score)
	INC HL
	LD (Score),HL
				
	;change number of bricks left
	LD HL,BricksNumber
	DEC (HL)
	JR NZ,DrawBall0
	;end of level,all bricks cleared
	LD A,1
	LD (WinStatus),A
			
ClearBatSizes
;there could be A problem with restoring background when ball is close to bat
;if bat is moving the restored background could store some parts of bat
;to avoid it draw empty squares at sides of bat	
	LD A,(BatL)	
	LD C,A
	CP 193;check if standing at left edge
	JR Z, ClearRightSide		
;left side	
	LD H,80
	LD L,C
	DEC L
	LD B,8
	XOR A
ClearLeftSide
	LD (HL),A
	INC H
	DJNZ ClearLeftSide
		
ClearRightSide
	LD A,C
	CP 219
	JR Z,DrawBall0;right edge
	LD H,80
	LD L,C
	INC L
	INC L
	INC L
	INC L
	LD B,8
	XOR A
ClearRightSide2
	LD (HL),A
	INC H
	DJNZ ClearRightSide2
		
;--------		
			
DrawBall0
	XOR A
	LD (ClearBrickNeeded),A	
				
;ball should be drawn at any HL		
	;read x,y AND transform to HL
	CALL CountBallHL
						
DrawBall1
	LD A,H
	AND 00000111b
	LD B,A
	LD C,A;nr of lines IN bottom char line	
	LD A,8
	SUB B
	LD B,A;nr of lines IN top char line
;-------	
;determine ball frame
	PUSH BC
	PUSH HL	
			
	LD A,(BallShift)
	LD B,A
	LD HL,Ball0
	LD DE,32	
	LD A,B
	OR A
	JR Z,DrawBall15; if shift=0 no need to count frame

BallFrame	
	ADD HL,DE
	DJNZ BallFrame	
;-------	
		
DrawBall15
	EX DE,HL ;ball frame IN DE
	POP HL
	POP BC	
				
	LD IX,BackBuffer		
	PUSH HL		
;draw upper line
DrawBall2		
	;left char
	LD A,(HL)
	LD (IX+0),A;background
	INC IX
	
	LD A,(DE)
	AND (HL)
	LD (HL),A;mask
	INC DE
	LD A,(DE)
	OR (HL)
	LD (HL),A;sprite
	INC DE	
	
	;right char
	INC L
	LD A,(HL)
	LD (IX+0),A;background
	INC IX
		
	LD A,(DE)
	AND (HL)
	LD (HL),A;mask
	INC DE
	LD A,(DE)
	OR (HL)
	LD (HL),A;sprite
	INC DE	
		
	INC H;next byte line
	DEC L	;go back to left char	
		
	DJNZ DrawBall2
								
;count bottom line	
	LD B,C; lines left to do
	POP HL
	LD A,C
	OR A
	RET z; end drawing ball if equal char no need for bottom line
		
	LD A,H
	AND 11111000b
	LD H,A

	LD A,L
	ADD A,32
	LD L,A
	JR NC, DrawBall4	
	LD A,H
	ADD A,8
	LD H,A
			
;draw bottom line	
DrawBall4
	;left char
	LD A,(HL)
	LD (IX+0),A;back
	INC IX
	
	LD A,(DE)
	AND (HL)
	LD (HL),A;mask
	INC DE
	LD A,(DE)
	OR (HL)
	LD (HL),A;sprite
	INC DE	
	
	;right char
	INC L
	LD A,(HL)
	LD (IX+0),A;back
	INC IX
		
	LD A,(DE)
	AND (HL)
	LD (HL),A;mask
	INC DE
	LD A,(DE)
	OR (HL)
	LD (HL),A;sprite
	INC DE	
		
	INC H;next byte line
	DEC L	;go back to left char	
	DJNZ DrawBall4
	RET
;--------CHANGE BALL COORS----------
ChangeBallCoors
	
ChangeXCor
	;change x coordinate	
	LD HL,BallX
	LD B,(HL)
	LD A,(BallSpeedX)
	ADD A,B
	LD (HL),A
	;check if left edge reached
	CP 8
	JR Z,ChangeXSpeed
	JR C,CorrectXPos1	
	
	;check if right edge reached	
	CP 240
	JR Z,ChangeXSpeed	
	JR NC,CorrectXPos2
	JR ChangeYCor			
		
;wall reached, 
CorrectXPos1
	;ball went behind the left edge, correction needed	
	LD A,8	
	LD (BallX),A
	JR ChangeXSpeed
CorrectXPos2
	;ball went behind the right edge, correction needed	
	LD A,240
	LD (BallX),A
			
ChangeXSpeed
	;speedx=-speedx
	LD HL,BallSpeedX
	LD A,(HL)
	CPL
	INC A
	LD (HL),A	
		
	
;-------------
ChangeYCor
	;change y coordinate	
	LD HL,BallY
	LD B,(HL)
	LD A,(BallSpeedY)
	ADD A,B
	LD (HL),A		
	;check if top edge reached
	CP 8
	JR Z,ChangeYSpeed
	JR C,CorrectYPos1	
	
	;check if level of bat reached	
	CP 168 
	JR NC,CorrectYPos2
	;check if bottom edge=Death reached	
	RET	;end of changing coordinates rOUTine		
		
;wall reached, speedy=-speedy
CorrectYPos1
	;ball went behind the top edge, correction needed	
	LD A,9
	LD (BallY),A
	JR ChangeYSpeed
ChangeYSpeed
	;speed y=-speed y
	LD HL,BallSpeedY
	LD A,(HL)
	CPL
	INC A
	LD (HL),A	
	RET
CorrectYPos2
;168 is the level of bat
;it is not enough to check if ball has achieved this position, because
;if ball moves E.g at speed 3, it could be at pos 167, AND then at 170,just skipping 168
;IN such case(ball went behind the bat level edge), correction is needed
;but when bat missed already the ball correction is no needed (to enable ball leve the screen)		
	LD A,(BallMissed)
	OR A
	JR NZ,CheckDeathLevel ;ball missed the bat so let it head to bottom edge
		
	LD A,168
	LD (BallY),A ;corect ball position to be exactly equal to bat position
	RET
		
CheckDeathLevel
	LD A,(BallY)
	CP 184
	CALL Z,SetDeath
	CALL NC,SetDeath				
	RET	
;--------BAT CONTACT----------------
CheckContactWithBat
	LD A,(BallY)
	CP 168; checks if ball is at bat level
	RET NZ; if no,return
	
	;check bat coordinates to determine if it hits the ball
	;
	;            0
	;       -----------
	;1)Bat right edge (batx+24) must be bigger than ball left edge (ballx)
	;and
	;2)Bat left edge (batx) must be lesser then ball right edge (ballx+8) 
	
	LD A,(BallX);read data
	LD B,A
	
	LD A,(BatX)
	
	;1)
	ADD A,23
	CP B					
	JR C,BallMiss
	;2)
	SUB 29;(A-23-6)		
	;if batx was very low E.g 4 subtracting 6 will give 254, so it needs corection)
	JR NC,CheckContact2
	XOR A ;if less than 0,correct it to 0
CheckContact2
	CP B
	JR NC, BallMiss	
	
	;ball hit bat sound
	LD B,28
BatSound1		
	LD C,100
	XOR A
	OUT (254),A
BatSound2
	DEC C
	NOP
	JR NZ, BatSound2
	LD A,16
	OUT (254),A
	DJNZ BatSound1
;----------		
;counting new bat speed
	
		
	LD A,(BallX);read data
	LD C,A
	LD A,(BatX)
	SUB 6
	LD B,A
	LD A,C
	SUB B ;as A result we get IN A A number 1-30 (24 bat width+6 left margin) which inform us
	;which part of bat is hit by ball (lower numbers left side, higher numbers right side)
		
		
	;Bat is Divided into 6 areas. Their cumulative width is IN batpart data 
	;AND we must now find which area is hit by ball, because each area has its own ball speed
				
	LD HL,BatParts
	LD DE,BallSpeeds
	LD C,A; number 1-30 stored IN C
	
FindBatPart	
	LD A,(HL)
	CP C
	;if ball position is less then current bat cumulative width
	;that means we found the area hitten by ball
	JR NC,BallPartFound		
	;go to next bat part	
	INC HL
	INC DE
	INC DE
	JR FindBatPart	
BallPartFound
	;read ball speed coordinates	
	LD A,(DE)	
	LD (BallSpeedX),A
	INC DE
	LD A,(DE)	
	LD (BallSpeedY),A
	RET
BatParts		
	.BYTE 6,11,15,19,24,30	
BallSpeeds	
	
	.BYTE 253,255
	.BYTE 254,254
	.BYTE 255,253
	.BYTE 1,253
	.BYTE 2,254		
	.BYTE 3,255	
		
BallMiss		
	LD A,1
	LD (BallMissed),A
	RET
		
BallMissed	.BYTE 0
		
;----------HIT BRICK--------		
HitBrick
	;finds if ball destroys A brick
	;to do it checks the ball square attribute
	;if it is colorful, it means the ball hit the brick
		
	;count ball attribute address	
		LD A,(BallH)
		LD H,A
		LD A,80
		SRL H
		SRL H
		SRL H
		ADD A,H
		LD H,A
		
		LD A,(BallL)
		LD L,A
	;Ball attributes address IN HL
		
		LD A,(HL)
		CP 71	
		RET z ;ball IN empty
		
		LD A,H
		CP 90
		RET Z; ball IN bottom par of screen where are no bricks,so do nothing
			;(different attribute means reaching score bar)
		
HitBrick2		
	;destroy brick
	
	;first color brick white on black to make it background
	;then (IN next frame)empty field appears IN place of brick	
	
	;find brick left side address
	;(ball may hit left,center OR right of brick,we must find its left)

	LD C,1
	LD A,L
	AND 00011111b;0-31	
FindBrick		
	
	CP C
	JR C,BrickFound1
	JR Z,BrickFound2;ball hits exactly left side,no need to change anything		

	INC C
	INC C
	INC C
	JR FindBrick
			
BrickFound1
	;make L Indicate to left side of brick
	DEC C
	DEC C
	DEC C
	LD A,L
	AND 11100000b
	ADD A,C
	LD L,A
BrickFound2	
		
;change attribute
	LD A,71
	LD (HL),A
	INC L
	LD (HL),A
	INC L
	LD (HL),A		
	DEC L
	DEC L
	;set clear brick values
	;need to read H,L is the same as IN attributes
	LD A,(BallH)
	AND 11111000b ;(64,72 OR 80)
	LD H,A ;brick address IN HL
	LD (ClearBrickHL),HL
		
	LD A,1
	LD (ClearBrickNeeded),A; do not restore background IN next game frame
		
		
	;invert speed
	;speed y=-speed y
	LD HL,BallSpeedY
	LD A,(HL)
	CPL
	INC A
	LD (HL),A	
;sound
	;ball hit brick sound
	LD B,28
BrickSound1		
	LD C,100
	XOR A
	OUT (254),A
BrickSound2
	DEC C
	NOP
	JR NZ, BrickSound2
	LD A,16
	OUT (254),A
	DJNZ BrickSound1
	RET		
ClearBrickNeeded	.BYTE 0
ClearBrickHL	.WORD 0
	
;------------LOSE LIFE-------
SetDeath
	LD A,184
	LD (BallY),A
	LD (DeathStatus),A
	LD (LoseLife),A	
		RET

Death
;--------
	;Death animation
	LD D,0
	LD C,55	
		
	;read bat attribute
	LD H,90
	LD A,(BatL)	
	LD L,A
			
		
DeathAnim1	
	HALT
	HALT
	XOR A
	OUT (254),A
	LD B,255
DeathAnim2
	LD A,16
	DJNZ DeathAnim2
	OUT (254),A
	;Flip bar attribute between 0 AND 71
	XOR A
	CP D
	JR NZ,DeathAnim3	
	LD A,71
DeathAnim3
	LD D,A
				
	LD (HL),A
	INC L
	LD (HL),A
	INC L
	LD (HL),A
	INC L
	LD (HL),A
	DEC L
	DEC L
	DEC L	
	DEC C
	JR NZ,DeathAnim1
		
;clear bat (going down animation)
	
	LD C,8	
DeathAnim4		
	LD H,80+6
	LD B,8

DeathAnim5
	XOR A
	OUT (254),A	
	
	;move down one line	
	PUSH BC
	LD B,(HL)
	INC L	
	LD C,(HL)
	INC L		
	LD D,(HL)
	INC L
	LD E,(HL);storing line finished		
	DEC L
	DEC L
	DEC L
	
	INC H;go one line down
	LD (HL),B
	INC L
	LD (HL),C
	INC L
	LD (HL),D
	INC L
	LD (HL),E;writing line finished
	
	DEC L
	DEC L
	DEC L	
	
	DEC H
	DEC H	;going two lines up
	
	POP BC	
	LD A,16
	OUT (254),A
		
	DJNZ DeathAnim5
	HALT
	HALT
	HALT
	HALT
	HALT
	HALT
	DEC C
	JR NZ,DeathAnim4	
;-------end animation
	;decrease lives
	LD HL,Lives
	DEC (HL)
	LD A,(HL)
	CP 255; less than 0
	JR Z,GameEnd		
	
	JP StartGame2
GameEnd
	LD HL,18571
	LD DE,GameOver
	CALL Typetext
	LD B,150	
GameEndDelay
	HALT
	DJNZ GameEndDelay
				
	JP StartGame
		
;----------------
WinLevel
	LD HL,18569
	LD DE,LevelCompl
	CALL Typetext
	LD B,100	
WinWait1		
	HALT
	DJNZ WinWait1
	
	LD A,(LevelNr)
	CALL DrawGirl ;drawing girl - reward for completing level
			
	LD HL,20709
	LD DE,PressCont
	CALL Typetext	

	LD A,(ControlOption)
	OR A
	JR Z,WinWaitKeys			
WinWaitJoy	
	LD BC,31
	IN A,(C)
	CP 16
	JR NZ,WinWaitJoy
	JR WinLevel2
WinWaitKeys
	LD BC,32766
	IN A,(C)
	BIT 2,A
	JR NZ,WinWaitKeys		
		
WinLevel2	
;Go to new level		
	LD HL,LevelNr
	INC (HL)
	
	;check if level 7 finished
	LD A,(HL)
	CP 8
	JR NZ,WinLevel3
	LD A,255; player begins with 0 lives
	LD (Lives),A	
	LD A,(LoseLife)
	OR A
	JR Z,WinLevel4 ;player didnt lose life, extra level
	JR NZ,WinGame			
		
	;check if level 8 finished
WinLevel3
	LD A,(HL)
	CP 9
	JR NZ,WinLevel4
	JR WinGame		

WinLevel4		
;bonus+ one life
	LD HL,Lives
	LD A,(HL)
	CP 9
	JP Z,StartGame1 ;can't have more than 9 lives
	INC (HL)	
	JP StartGame1
;------		
WinGame
				
	;dark
	XOR A
	OUT (254),A
	LD HL,22528
	LD (HL),A
	LD DE,22529	
	LD BC,767		
	LDIR
	LD HL,18504
	LD DE,WinText1
	CALL Typetext
	LD HL,18562
	LD DE,WinText2
	CALL Typetext
		
	LD HL,18592
	LD A,(LoseLife)	
	OR A
	JR Z,WinGame2
	LD DE,LoseLifeWinText
	JR WinGame3				
WinGame2
	LD DE,NoLoseLifeWinText

				
WinGame3
	CALL Typetext			
	LD B,200
WinGameWait
	HALT
	DJNZ WinGameWait		
	JP StartGame		
			
				
;---------TEXT-----------
Typetext	
; This rouine types text
;HL; contains position of text on screen
;DE contains text address IN memory
;BC is used		

	;Default text color is blue on black
	LD A,71
	LD (TextColor),A
		
	LD (TextLineAd),HL
	
text1	
	;Check if end of string
	LD A,(DE)
	AND A
	JR Z,	TextEnd ;end of text if zero
	
	CP 63; checks if should go to new line
	JR Z,TextNewLine
	CP 51; checks if color change
	JR Z,TextColorChange
	;letter attribute	
	PUSH HL
	LD A,80
	SRL H
	SRL H
	SRL H
	ADD A,H
	LD H,A
	LD A,(TextColor)
	LD (HL),A
	POP HL
	;draw A letter
	LD A,(DE)	;code of letter loaded
	LD BC,Letters-8;start of letters sprites
	
	;Count address of letter
	
	SLA A
	SLA A
	SLA A		;A=A*8 (with carry)to count adress of letter		
	
	PUSH HL
	LD HL,0
		
	LD L,A
	LD A,0
	ADC A,H	
	LD H,A	;HL=A*8	
	ADD HL,BC
	LD B,H
	LD C,L	;BC loaded with letter sprite address
	POP HL
		
				;address of printed letter placed IN BC
	
text2		
	PUSH HL
	PUSH DE
	LD E,8
text3	LD A,(BC)	;read letter data
	LD (HL),A	;AND print it IN screen		
	INC H
	INC BC	;go to another byte
	DEC E
	JR NZ, text3
	POP DE
	POP HL

;go to another letter			
	INC L	;next char on the screen
	INC DE ;next letter
	JR text1
		
TextNewLine
	;this subroutine goes one line down	with text
	LD HL,(TextLineAd)	;beginning of current line IN HL
	CALL CountNextLine	;count address of one line down AND place it IN HL
	LD (TextLineAd),HL	;Update value
	INC DE			;Next letter
	JR text1			;go to letter printing rOUTine
TextColorChange
	INC DE
	LD A,(DE);read new color
	LD (TextColor),A; AND write it to proper cell			
	INC DE; go to next letter
	JR text1
;---------
CountNextLine
	;routine takes HL address of screen byte AND counts address of byte one line lower
	LD A,L
	ADD A,32
	LD L,A; go to next line
	RET NC; if no next screen segment,just Return
		;go to next screen segment if needed
		LD A,H
		ADD A,8
		LD H,A
	RET
;---------------
CountBallHL
	LD HL,BallX
	LD B,(HL)
	LD A,B
	AND 00000111b
	LD (BallShift),A
	INC HL
	LD C,(HL)
	CALL XYtoHL
	LD A,H
	LD (BallH),A
	LD A,L
	LD (BallL),A
	RET			
;-----------				
TextEnd RET	
TextColor .BYTE 71; this cell stores text attribute
TextLineAd .WORD 16384;this 2 cells store screen address 
			   ;of currently printed text line (address of 1st char, to be exact)

;Texts
KeysText
	.BYTE 51,69,29,27,11,5,25,2,15,1,18,4,27,15,27,16,27,13,0
JoyText
	.BYTE 51,69,30,27,11,5,13,16,19,20,15,14,27,10,15,25,19,20,9,3,11,0
StartText
	.BYTE 51,69,31,27,19,20,1,18,20,27,7,1,13,5,0
LevelCompl
	.BYTE 12,5,22,5,12,27,3,15,13,16,12,5,20,5,4,0				
PressCont
	.BYTE 51,71,16,18,5,19,19,27,6,9,18,5,27,20,15,27,3,15,14,20,9,14,21,5,0
GameOver
	.BYTE 7,1,13,5,27,27,15,22,5,18,0
WinText1
	.BYTE 3,15,14,7,18,1,20,21,12,1,20,9,15,14,19,0
WinText2		
	.BYTE 25,15,21,27,8,1,22,5,27,3,15,13,16,12,5,20,5,4,27,20,8,5,27,7,1,13,5,0
LoseLifeWinText
	.BYTE 63,27,14,5,24,20,27,20,9,13,5,27,20,18,25,27,20,15,27,3,15,13,16,12,5,20,5,27
	.BYTE	7,1,13,5,63
	.BYTE 27,27,27,27,27,23,9,20,8,15,21,20,27,12,15,19,9,14,7,27,1,27,12,9,6,5,63
	.BYTE 27,20,8,5,18,5,27,9,19,27,1,14,27,5,24,20,18,1,27
	.BYTE 7,9,18,12,27,23,1,9,20,9,14,7,0	
NoLoseLifeWinText
	.BYTE 27,27,27,27,27,25,15,21,27,1,18,5,27,1,27,7,18,5,1,20,27,16,12,1,25,5,18,0			
		
AuthorText
	.BYTE 18,1,6,1,12,27,13,9,1,26,7,1,63,27,27,27,27,30,28,28,35,0					
					
LevelStart
	.BYTE 51,69,12,5,22,5,12,27
LevelNrText
	.BYTE 1,0
;girl names
Stella
	.BYTE 19,20,5,12,12,1,0	
Mariko
	.BYTE 13,1,18,9,11,15,0	
Sharon
	.BYTE 19,8,1,18,15,14,0
Tracy
	.BYTE 27,20,18,1,3,25,0	
Yoko
	.BYTE 27,25,15,11,15,0
Tanya	
	.BYTE 27,20,1,14,25,1,0
Vanessa
	.BYTE 22,1,14,5,19,19,1,0
Emma
	.BYTE 27,5,13,13,1,0		
GirlNames
	.WORD Stella
	.WORD Mariko
	.WORD Sharon
	.WORD Tracy
	.WORD Yoko
	.WORD Tanya
	.WORD Vanessa
	.WORD Emma							
;---------Display Bricks-------------
DisplayBricks
		
	;left AND right edge	
DisplayEdge1
	
	LD B,24	
	LD HL,16384
DisplayEdge2
	PUSH BC
	PUSH HL		
	
	LD BC,256+1
	LD DE,Edge1
	LD IX,8 ;this cell contains 17(empty byte)
	CALL DrawTile ;left edge		
	
	POP HL
	PUSH HL
	LD A,L
	ADD A,31
	LD L,A
	LD BC,256+1
	LD DE,Edge2
	CALL DrawTile ;right edge	
		
	POP HL
	POP BC
	
	LD A,L
	ADD A,32
	LD L,A
	JR NC,DisplayEdge3
	LD A,H
	ADD A,8
	LD H,A
DisplayEdge3
	DJNZ DisplayEdge2
	
	;top edge
	LD B,30
	LD HL,16385
DisplayEdge4
	PUSH BC
	PUSH HL
	LD BC,257
	LD DE,Edge3	
	CALL DrawTile
	POP HL
	POP BC
	INC L
	DJNZ DisplayEdge4	
;corners
	
	LD BC,257
	PUSH BC	
	LD DE,Corner1
	LD HL,16384
	CALL DrawTile
	POP BC
	LD DE,Corner2
	LD HL,16384+31
	CALL DrawTile					
								
DrawBricks
	;find currentleveldata	
	LD A,(LevelNr)
	LD HL,LevelsLabels-2
FindLevelData	
	INC HL
	INC HL
	DEC A
	JR NZ,FindLevelData
	
	LD E,(HL)
	INC HL
	LD D,(HL)
	PUSH DE
	POP IX	
	;start of level data IN IX	
		
	LD A,(IX+0);load number of bricks
	LD B,A	
	LD (BricksNumber),A
			
	LD HL,16385+32	
DrawBricks2	
	PUSH BC
	PUSH HL
	LD BC,3*256+1
	LD DE,Brick
	CALL DrawTile
	POP HL
	POP BC
		
	LD A,L
	ADD A,3
	LD L,A
	AND 00011111b
	CP 31; ten bricks IN the line, reaching collumn 31 means need to go
		;down one line AND begin from collumn 1	
	JR NZ,DrawBricks3
	LD A,L
	ADD A,2
	LD L,A
	JR NC,DrawBricks3	
	;new segment reached when going one line down
	LD A,H
	ADD A,8
	LD H,A
DrawBricks3
	DJNZ DrawBricks2
							
ColorBricks
	LD B,(IX+0);bricks number
	LD HL,22529+32;first brick screen address
	INC IX
	PUSH IX
	POP DE; bricks color data address
	
	
ColorBricks2	
	;one brick	
	LD A,(DE)
	LD (HL),A
	INC HL
	LD (HL),A
	INC HL
	LD (HL),A		
	INC HL
	INC DE
	;check end of line	
	PUSH AF
	LD A,L
	AND 00011111b
	CP 31
	JR NZ,ColorBricks3
	;go to new line
	INC HL
	INC HL
ColorBricks3
	POP AF
	DJNZ ColorBricks2					
	RET
